class SearchController < ApplicationController

  include SearchEngine::OrientdbLucene

  def index
    objectsFound = []

    page=1
    if (params[:page])
      page = params[:page].to_i
    end

    @pagination_limit=10
    if (params[:page_limit])
      @pagination_limit=params[:page_limit].to_i
    end

    unless params[:qry].blank?
      objectsFound = search params[:qry], params[:sort]
      @numFound = objectsFound.length

      # if params[:sort]
      #   @ordena = params[:sort]
      # end
      #
      # case params[:sort]
      # when "author"
      #   objectsFound = sort_author(objectsFound);
      # when "publicationasc"
      #   objectsFound = objectsFound.sort_by{|item| [ item.id ]}
      # when "publicationdesc"
      #   # objectsFound = objectsFound.sort_by{|item| - item.id }
      #   objectsFound
      # when "relevance"
      #   items = objectsFound.collect{ |x| Ranking::Item.new(x.name,x.views,0,x.likes,x)  } #puts each object in an item
      #
      #   rater = Ranking::Rater.new(
      #       Ranking::Strategies::BasicRater.new(
      #           #define sorting weights
      #           positionWeight = 1000,
      #           useWeight = 1,
      #           likeWeight = 100
      #       )
      #   )
      #
      #   a = rater.sortByRate(items) # Returns sorted array of items
      #   objectsFound = a.collect{ |x|  x.info  } #get only the info fields(objects)
      # end
    end

    # build objects from one page only
    @objects = build_page_result(objectsFound, page, @pagination_limit)

    @result = Kaminari.paginate_array(objectsFound).page(page).per(@pagination_limit)
  end

  private

  def build_page_result(objects, page, limit)
    start = (page * limit) - limit
    offset = page * limit - 1
    # build only objects from page
    LearningObjectBuilder.build(objects[start..offset])
  end

  def sort_author(items)
    # items = items.sort_by{|item| [ item['author'].to_s.downcase ]}
    # items.each{ |item| item['author'] = sort_author(item['author']) if (item['author'].nil? ? [] : item['author']).size > 0 }
    items
  end
end
